<?php

namespace frontend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use frontend\models\Options;

/**
 * OptionsSearch represents the model behind the search form about `frontend\models\Options`.
 */
class OptionsSearch extends Options
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['option_id', 'option_parent', 'option_translatable'], 'integer'],
            [['option_key', 'option_format'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Options::find();

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'option_id' => $this->option_id,
            'option_parent' => $this->option_parent,
            'option_translatable' => $this->option_translatable,
        ]);

        $query->andFilterWhere(['like', 'option_key', $this->option_key])
            ->andFilterWhere(['like', 'option_format', $this->option_format]);

        return $dataProvider;
    }
}
